import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import _ from 'lodash';
import program from 'commander';
import { parse } from 'graphql';
import { isCustomObject, translateType } from './dataTypes';
import modelNames from './modelNames';
export function parseModelsFromSchema(schema) {
  var parsedSchema = parse(schema);
  var models = [];

  var _iterator = _createForOfIteratorHelper(parsedSchema.definitions),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var definition = _step.value;
      var model = {
        name: definition.name.value,
        root: process.cwd() + '/api-test',
        force: program.force,
        verbose: program.verbose,
        modelType: definition.name.value
      };
      var fields = [];
      var relations = [];

      var _iterator3 = _createForOfIteratorHelper(definition.fields),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var field = _step3.value;
          var modelType = field.type.type ? translateType(field.type.type.name.value) : translateType(field.type.name.value);

          if (isCustomObject(modelType)) {
            fields.push({
              name: field.name.value
            });
            relations.push({
              name: field.name.value,
              modelType: modelType,
              relationType: field.type.kind === 'ListType' ? 'hasMany' : 'belongsTo'
            });
          } else if (field.name.value !== 'id') {
            fields.push({
              name: field.name.value,
              type: modelType
            });
          }

          model = _objectSpread(_objectSpread({}, model), {}, {
            fields: fields,
            relations: relations
          });
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      model = _objectSpread(_objectSpread({}, model), modelNames(model.name));
      models.push(model);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  var _loop = function _loop() {
    var model = _models[_i];

    var _iterator2 = _createForOfIteratorHelper(model.relations),
        _step2;

    try {
      var _loop2 = function _loop2() {
        var relation = _step2.value;
        relation.model = _.find(models, function (m) {
          return m.modelType === relation.modelType;
        });

        if (relation.relationType === 'hasMany') {
          var reverseRelation = _.find(relation.model.relations, function (m) {
            return m.modelType === model.modelType;
          });

          if (reverseRelation.relationType === 'hasMany') relation.m2m = true;
        }
      };

      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        _loop2();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  };

  for (var _i = 0, _models = models; _i < _models.length; _i++) {
    _loop();
  }

  return models;
}